% initialisation
clear; close all;


% etape 1 :on selectionne les mois d ete (attention aux annees bixestiles!)
%          on compile sous forme d'un seul fichier

hgt700=zeros(122,49,144,28);

siz=31+28+31+30+31+1; sizbis=31+28+31+30+31+30+31+31+30;
ncload('hgt700.1979.nc'); hgt700(:,:,:,1)=hgt(siz:sizbis,1,:,:); clear hgt;
ncload('hgt700.1980.nc'); hgt700(:,:,:,2)=hgt(siz+1:sizbis+1,1,:,:); clear hgt;
ncload('hgt700.1981.nc'); hgt700(:,:,:,3)=hgt(siz:sizbis,1,:,:);clear hgt;
ncload('hgt700.1982.nc'); hgt700(:,:,:,4)=hgt(siz:sizbis,1,:,:);clear hgt;
ncload('hgt700.1983.nc'); hgt700(:,:,:,5)=hgt(siz:sizbis,1,:,:);clear hgt;
ncload('hgt700.1984.nc'); hgt700(:,:,:,6)=hgt(siz+1:sizbis+1,1,:,:);clear hgt;
ncload('hgt700.1985.nc'); hgt700(:,:,:,7)=hgt(siz:sizbis,1,:,:);clear hgt;
ncload('hgt700.1986.nc'); hgt700(:,:,:,8)=hgt(siz:sizbis,1,:,:);clear hgt;
ncload('hgt700.1987.nc'); hgt700(:,:,:,9)=hgt(siz:sizbis,1,:,:);clear hgt;
ncload('hgt700.1988.nc'); hgt700(:,:,:,10)=hgt(siz+1:sizbis+1,1,:,:);clear hgt;
ncload('hgt700.1989.nc'); hgt700(:,:,:,11)=hgt(siz:sizbis,1,:,:);clear hgt;
ncload('hgt700.1990.nc'); hgt700(:,:,:,12)=hgt(siz:sizbis,1,:,:);clear hgt;
ncload('hgt700.1991.nc'); hgt700(:,:,:,13)=hgt(siz:sizbis,1,:,:);clear hgt;
ncload('hgt700.1992.nc'); hgt700(:,:,:,14)=hgt(siz+1:sizbis+1,1,:,:);clear hgt;
ncload('hgt700.1993.nc'); hgt700(:,:,:,15)=hgt(siz:sizbis,1,:,:);clear hgt;
ncload('hgt700.1994.nc'); hgt700(:,:,:,16)=hgt(siz:sizbis,1,:,:);clear hgt;
ncload('hgt700.1995.nc'); hgt700(:,:,:,17)=hgt(siz:sizbis,1,:,:);clear hgt;
ncload('hgt700.1996.nc'); hgt700(:,:,:,18)=hgt(siz+1:sizbis+1,1,:,:);clear hgt;
ncload('hgt700.1997.nc'); hgt700(:,:,:,19)=hgt(siz:sizbis,1,:,:);clear hgt;
ncload('hgt700.1998.nc'); hgt700(:,:,:,20)=hgt(siz:sizbis,1,:,:);clear hgt;
ncload('hgt700.1999.nc'); hgt700(:,:,:,21)=hgt(siz:sizbis,1,:,:);clear hgt;
ncload('hgt700.2000.nc'); hgt700(:,:,:,22)=hgt(siz+1:sizbis+1,1,:,:);clear hgt;
ncload('hgt700.2001.nc'); hgt700(:,:,:,23)=hgt(siz:sizbis,1,:,:);clear hgt;
ncload('hgt700.2002.nc'); hgt700(:,:,:,24)=hgt(siz:sizbis,1,:,:);clear hgt;
ncload('hgt700.2003.nc'); hgt700(:,:,:,25)=hgt(siz:sizbis,1,:,:);clear hgt;
ncload('hgt700.2004.nc'); hgt700(:,:,:,26)=hgt(siz+1:sizbis+1,1,:,:);clear hgt;
ncload('hgt700.2005.nc'); hgt700(:,:,:,27)=hgt(siz:sizbis,1,:,:);clear hgt;
ncload('hgt700.2006.nc'); hgt700(:,:,:,28)=hgt(siz:sizbis,1,:,:);clear hgt;


clear siz1 siz1bis;

hgt=permute(hgt700,[1 4 2 3]);
clear hgt700;


%%%%%%%%%%%%%%% FICHIER OLR
% ouverture / lecture du fichier 
load eof12_rossby_30100.txt
ind_olr=reshape(eof12_rossby_30100,122,28);
k=122*28;
clear eof12_rossby_30100
% on calcule l ecart type sur la serie entiere de l OLR
ind_olr1=reshape(ind_olr, k,1);
ind_olr2=std(ind_olr1); clear ind_olr1;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% GEOPOTENTIEL
% intialisation des tableaux
hgt700_filtre_compomax=NaN*ones(60,31,49,144); 
hgt700_filtre_compomin=NaN*ones(60,31,49,144);

compteurmax=0; 
compteurmin=0;

for a=1:28; % boucle sur les annees
   clear delta; 
   delta=zeros(122,1);
   for b=1:122; % boucle sur les jours : on prepare avant   
        if b>1;
            delta(b)=ind_olr(b,a)-ind_olr(b-1,a);
        end;
   end;
   for b=1:122; % boucle sur les jours
      if (b>22 && b<112); % 1ere condition (laisser une marge de 10) 
% cas 1 : max deltas apres negetifs et deltas avant postifs   
         if (delta(b+1)<0 && delta(b)<0 && delta(b-1)>0 && delta(b-2)>0 && ind_olr(b,a)>ind_olr2); 
            compteurmax=compteurmax+1;
            hgt700_filtre_compomax(compteurmax,1,:,:)=hgt(b-21,a,:,:);
            hgt700_filtre_compomax(compteurmax,2,:,:)=hgt(b-20,a,:,:);
            hgt700_filtre_compomax(compteurmax,3,:,:)=hgt(b-19,a,:,:);
            hgt700_filtre_compomax(compteurmax,4,:,:)=hgt(b-18,a,:,:);
            hgt700_filtre_compomax(compteurmax,5,:,:)=hgt(b-17,a,:,:);
            hgt700_filtre_compomax(compteurmax,6,:,:)=hgt(b-16,a,:,:);
            hgt700_filtre_compomax(compteurmax,7,:,:)=hgt(b-15,a,:,:);
            hgt700_filtre_compomax(compteurmax,8,:,:)=hgt(b-14,a,:,:);
            hgt700_filtre_compomax(compteurmax,9,:,:)=hgt(b-13,a,:,:);
            hgt700_filtre_compomax(compteurmax,10,:,:)=hgt(b-12,a,:,:);
            hgt700_filtre_compomax(compteurmax,11,:,:)=hgt(b-11,a,:,:);

            hgt700_filtre_compomax(compteurmax,12,:,:)=hgt(b-10,a,:,:);
            hgt700_filtre_compomax(compteurmax,13,:,:)=hgt(b-9,a,:,:);
            hgt700_filtre_compomax(compteurmax,14,:,:)=hgt(b-8,a,:,:);
            hgt700_filtre_compomax(compteurmax,15,:,:)=hgt(b-7,a,:,:);
            hgt700_filtre_compomax(compteurmax,16,:,:)=hgt(b-6,a,:,:);
            hgt700_filtre_compomax(compteurmax,17,:,:)=hgt(b-5,a,:,:);
            hgt700_filtre_compomax(compteurmax,18,:,:)=hgt(b-4,a,:,:);
            hgt700_filtre_compomax(compteurmax,19,:,:)=hgt(b-3,a,:,:);
            hgt700_filtre_compomax(compteurmax,20,:,:)=hgt(b-2,a,:,:);
            hgt700_filtre_compomax(compteurmax,21,:,:)=hgt(b-1,a,:,:);

            hgt700_filtre_compomax(compteurmax,22,:,:)=hgt(b,a,:,:);
            hgt700_filtre_compomax(compteurmax,23,:,:)=hgt(b+1,a,:,:);
            hgt700_filtre_compomax(compteurmax,24,:,:)=hgt(b+2,a,:,:);
            hgt700_filtre_compomax(compteurmax,25,:,:)=hgt(b+3,a,:,:);
            hgt700_filtre_compomax(compteurmax,26,:,:)=hgt(b+4,a,:,:);
            hgt700_filtre_compomax(compteurmax,27,:,:)=hgt(b+5,a,:,:);
            hgt700_filtre_compomax(compteurmax,28,:,:)=hgt(b+6,a,:,:);
            hgt700_filtre_compomax(compteurmax,29,:,:)=hgt(b+7,a,:,:);
            hgt700_filtre_compomax(compteurmax,30,:,:)=hgt(b+8,a,:,:);
            hgt700_filtre_compomax(compteurmax,31,:,:)=hgt(b+9,a,:,:);

% cas 2 : min deltas apres positifs et deltas avant negatifs   
         elseif (delta(b+1)>0 && delta(b)>0 && delta(b-1)<0 && delta(b-2)<0 && ind_olr(b,a)<(-ind_olr2));
            compteurmin=compteurmin+1;
            hgt700_filtre_compomin(compteurmin,1,:,:)=hgt(b-21,a,:,:);
            hgt700_filtre_compomin(compteurmin,2,:,:)=hgt(b-20,a,:,:);
            hgt700_filtre_compomin(compteurmin,3,:,:)=hgt(b-19,a,:,:);
            hgt700_filtre_compomin(compteurmin,4,:,:)=hgt(b-18,a,:,:);
            hgt700_filtre_compomin(compteurmin,5,:,:)=hgt(b-17,a,:,:);
            hgt700_filtre_compomin(compteurmin,6,:,:)=hgt(b-16,a,:,:);
            hgt700_filtre_compomin(compteurmin,7,:,:)=hgt(b-15,a,:,:);
            hgt700_filtre_compomin(compteurmin,8,:,:)=hgt(b-14,a,:,:);
            hgt700_filtre_compomin(compteurmin,9,:,:)=hgt(b-13,a,:,:);
            hgt700_filtre_compomin(compteurmin,10,:,:)=hgt(b-12,a,:,:);
            hgt700_filtre_compomin(compteurmin,11,:,:)=hgt(b-11,a,:,:);

            hgt700_filtre_compomin(compteurmin,12,:,:)=hgt(b-10,a,:,:);
            hgt700_filtre_compomin(compteurmin,13,:,:)=hgt(b-9,a,:,:);
            hgt700_filtre_compomin(compteurmin,14,:,:)=hgt(b-8,a,:,:);
            hgt700_filtre_compomin(compteurmin,15,:,:)=hgt(b-7,a,:,:);
            hgt700_filtre_compomin(compteurmin,16,:,:)=hgt(b-6,a,:,:);
            hgt700_filtre_compomin(compteurmin,17,:,:)=hgt(b-5,a,:,:);
            hgt700_filtre_compomin(compteurmin,18,:,:)=hgt(b-4,a,:,:);
            hgt700_filtre_compomin(compteurmin,19,:,:)=hgt(b-3,a,:,:);
            hgt700_filtre_compomin(compteurmin,20,:,:)=hgt(b-2,a,:,:);
            hgt700_filtre_compomin(compteurmin,21,:,:)=hgt(b-1,a,:,:);

            hgt700_filtre_compomin(compteurmin,22,:,:)=hgt(b,a,:,:);
            hgt700_filtre_compomin(compteurmin,23,:,:)=hgt(b+1,a,:,:);
            hgt700_filtre_compomin(compteurmin,24,:,:)=hgt(b+2,a,:,:);
            hgt700_filtre_compomin(compteurmin,25,:,:)=hgt(b+3,a,:,:);
            hgt700_filtre_compomin(compteurmin,26,:,:)=hgt(b+4,a,:,:);
            hgt700_filtre_compomin(compteurmin,27,:,:)=hgt(b+5,a,:,:);
            hgt700_filtre_compomin(compteurmin,28,:,:)=hgt(b+6,a,:,:);
            hgt700_filtre_compomin(compteurmin,29,:,:)=hgt(b+7,a,:,:);
            hgt700_filtre_compomin(compteurmin,30,:,:)=hgt(b+8,a,:,:);
            hgt700_filtre_compomin(compteurmin,31,:,:)=hgt(b+9,a,:,:);
           
         end;
      end;
   end;         
end;


% on fait la somme des valeurs de hgt700_filtreentiel sur le nbre d occurences
% on obtent un tableau de la forme (jours-avant-apres,lon,lat)
hgt700_filtre_compomin1(:,:,:)=nanmean(hgt700_filtre_compomin); clear hgt700_filtre_compomin;
hgt700_filtre_compomax1(:,:,:)=nanmean(hgt700_filtre_compomax); clear hgt700_filtre_compomax;

x=[-10:1:10]'; %'

figure(1); 
orient('landscape');
lat=lat';

for e=1:31;
       clear delta_hgt700_filtre_min;
       delta_hgt700_filtre_min=zeros(49,144);
       for b=1:49;
          for c=1:144;
             delta_hgt700_filtre_min(b,c)=hgt700_filtre_compomin1(e,b,c)-hgt700_filtre_compomax1(e,b,c);
          end;
       end;
       delta_hgt700=zeros(49,144);
       delta_hgt700(:,1:72)=delta_hgt700_filtre_min(:,73:144);
       delta_hgt700(:,73:144)=delta_hgt700_filtre_min(:,1:72);
       delta_hgt700_filtre_min=flipud(delta_hgt700);

       if e==1;
            sauvegrads('composite_hgt700_mode_rossby_30100_moins21',delta_hgt700_filtre_min,[-180 2.5 -10 2.5]);
       elseif e==2;
            sauvegrads('composite_hgt700_mode_rossby_30100_moins20',delta_hgt700_filtre_min,[-180 2.5 -10 2.5]);
       elseif e==3;
            sauvegrads('composite_hgt700_mode_rossby_30100_moins19',delta_hgt700_filtre_min,[-180 2.5 -10 2.5]);
       elseif e==4;
            sauvegrads('composite_hgt700_mode_rossby_30100_moins18',delta_hgt700_filtre_min,[-180 2.5 -10 2.5]);
       elseif e==5;
            sauvegrads('composite_hgt700_mode_rossby_30100_moins17',delta_hgt700_filtre_min,[-180 2.5 -10 2.5]);
       elseif e==6;
            sauvegrads('composite_hgt700_mode_rossby_30100_moins16',delta_hgt700_filtre_min,[-180 2.5 -10 2.5]);
       elseif e==7;
            sauvegrads('composite_hgt700_mode_rossby_30100_moins15',delta_hgt700_filtre_min,[-180 2.5 -10 2.5]);
       elseif e==8;
            sauvegrads('composite_hgt700_mode_rossby_30100_moins14',delta_hgt700_filtre_min,[-180 2.5 -10 2.5]);
       elseif e==9;
            sauvegrads('composite_hgt700_mode_rossby_30100_moins13',delta_hgt700_filtre_min,[-180 2.5 -10 2.5]);
       elseif e==10;
            sauvegrads('composite_hgt700_mode_rossby_30100_moins12',delta_hgt700_filtre_min,[-180 2.5 -10 2.5]);
       elseif e==11;
            sauvegrads('composite_hgt700_mode_rossby_30100_moins11',delta_hgt700_filtre_min,[-180 2.5 -10 2.5]);
       elseif e==12;
            sauvegrads('composite_hgt700_mode_rossby_30100_moins10',delta_hgt700_filtre_min,[-180 2.5 -10 2.5]);
       elseif e==13;
            sauvegrads('composite_hgt700_mode_rossby_30100_moins9',delta_hgt700_filtre_min,[-180 2.5 -10 2.5]);
       elseif e==14;
            sauvegrads('composite_hgt700_mode_rossby_30100_moins8',delta_hgt700_filtre_min,[-180 2.5 -10 2.5]);
       elseif e==15;
            sauvegrads('composite_hgt700_mode_rossby_30100_moins7',delta_hgt700_filtre_min,[-180 2.5 -10 2.5]);
       elseif e==16;
            sauvegrads('composite_hgt700_mode_rossby_30100_moins6',delta_hgt700_filtre_min,[-180 2.5 -10 2.5]);
       elseif e==17;
            sauvegrads('composite_hgt700_mode_rossby_30100_moins5',delta_hgt700_filtre_min,[-180 2.5 -10 2.5]);
       elseif e==18;
            sauvegrads('composite_hgt700_mode_rossby_30100_moins4',delta_hgt700_filtre_min,[-180 2.5 -10 2.5]);
       elseif e==19;
            sauvegrads('composite_hgt700_mode_rossby_30100_moins3',delta_hgt700_filtre_min,[-180 2.5 -10 2.5]);
       elseif e==20;
            sauvegrads('composite_hgt700_mode_rossby_30100_moins2',delta_hgt700_filtre_min,[-180 2.5 -10 2.5]);
       elseif e==21;
            sauvegrads('composite_hgt700_mode_rossby_30100_moins1',delta_hgt700_filtre_min,[-180 2.5 -10 2.5]);
       elseif e==22;
            sauvegrads('composite_hgt700_mode_rossby_30100_0',delta_hgt700_filtre_min,[-180 2.5 -10 2.5]);
       elseif e==23;
            sauvegrads('composite_hgt700_mode_rossby_30100_plus1',delta_hgt700_filtre_min,[-180 2.5 -10 2.5]);
       elseif e==24;
            sauvegrads('composite_hgt700_mode_rossby_30100_plus2',delta_hgt700_filtre_min,[-180 2.5 -10 2.5]);
       elseif e==25;
            sauvegrads('composite_hgt700_mode_rossby_30100_plus3',delta_hgt700_filtre_min,[-180 2.5 -10 2.5]);
       elseif e==26;
            sauvegrads('composite_hgt700_mode_rossby_30100_plus4',delta_hgt700_filtre_min,[-180 2.5 -10 2.5]);
       elseif e==27;
            sauvegrads('composite_hgt700_mode_rossby_30100_plus5',delta_hgt700_filtre_min,[-180 2.5 -10 2.5]);
       elseif e==28;
            sauvegrads('composite_hgt700_mode_rossby_30100_plus6',delta_hgt700_filtre_min,[-180 2.5 -10 2.5]);
       elseif e==29;
            sauvegrads('composite_hgt700_mode_rossby_30100_plus7',delta_hgt700_filtre_min,[-180 2.5 -10 2.5]);
       elseif e==30;
            sauvegrads('composite_hgt700_mode_rossby_30100_plus8',delta_hgt700_filtre_min,[-180 2.5 -10 2.5]);
       elseif e==31;
            sauvegrads('composite_hgt700_mode_rossby_30100_plus9',delta_hgt700_filtre_min,[-180 2.5 -10 2.5]);
       end
       delta_hgt700_filtre_min=flipud(delta_hgt700_filtre_min);
end
